<template>
  <v-container fluid ma-0 pa-2 white>
    <v-form
      ref="jrTicket"
      v-model="valid"
      lazy-validation
    >
      <v-row class="mr-5 ml-1 mb-0 pb-0 mt-1">
        <v-col cols="12" sm="3" md="2" class="pt-0 pb-0 mt-0 mb-0">
            <v-select
              v-model="valueBoard.id"
              :items="itemsBoard"
              label="Board Name"
              item-text="name"
              item-value="id"
              return-object
              hide-details
              required
              :rules="emptyRules.select"
              @change="boardChange()"
            ></v-select>
        </v-col>
        <v-col cols="12" sm="2" md="3" class="pt-0 pb-0 mt-0 mb-0">
          <v-select
            v-model="valueProject.key"
            :items="itemsProject"
            label="Project Name"
            item-text="name"
            item-value="key"
            multiple
            hide-details
            return-object
          ></v-select>
        </v-col>
        <v-col cols="12" sm="1" md="1" class="pt-0 pb-0 mt-0 mb-0 pl-0 pr-0">
          <v-checkbox
            v-model="isSearchByDate"
            label="Search by date"
            hide-details
          ></v-checkbox>
        </v-col>
      
        <v-col cols="12" sm="1" md="1" class="pt-0 pb-0 mt-0 mb-0 pl-0 pr-0">
          <v-menu
            ref="menu"
            v-model="menu"
            :close-on-content-click="false"
            :return-value.sync="date"
            transition="scale-transition"
            offset-y
            hide-details
            min-width="auto"
            
          >
            <template v-slot:activator="{ on, attrs }">
              <v-text-field
                v-model="date"
                label="Start Date"
                prepend-icon="mdi-calendar"
                readonly
                v-bind="attrs"
                v-on="on"
                hide-details
                :disabled="!isSearchByDate"
              ></v-text-field>
            </template>
            <v-date-picker v-model="date" no-title scrollable>
              <v-spacer></v-spacer>
              <v-btn text color="primary" @click="menu = false"> Cancel </v-btn>
              <v-btn text color="primary" @click="$refs.menu.save(date)">
                OK
              </v-btn>
            </v-date-picker>
          </v-menu>
        </v-col>
        <v-col cols="12" sm="1" md="1" class="pt-0 pb-0 mt-0 mb-0 pl-0 pr-0">
          <v-menu
            ref="menu2"
            v-model="menu2"
            :close-on-content-click="false"
            :return-value.sync="date2"
            transition="scale-transition"
            offset-y
            min-width="auto"
            hide-details
          >
            <template v-slot:activator="{ on, attrs }">
              <v-text-field
                v-model="date2"
                label="End Date"
                prepend-icon="mdi-calendar"
                readonly
                v-bind="attrs"
                v-on="on"
                hide-details
                :disabled="!isSearchByDate"
              ></v-text-field>
            </template>
            <v-date-picker v-model="date2" no-title scrollable>
              <v-spacer></v-spacer>
              <v-btn text color="primary" @click="menu2 = false"> Cancel </v-btn>
              <v-btn text color="primary" @click="$refs.menu2.save(date2)">
                OK
              </v-btn>
            </v-date-picker>
          </v-menu>
        </v-col>
        
        <v-col cols="12" sm="2" md="2" class="pt-0 pb-0 mt-0 mb-0">
          <v-row>
            <v-col cols="6">
              <v-text-field
                v-model="prefixCodeProject"
                counter="50"
                label="Code"
                hide-details
                required
                :rules="emptyRules.text"
              ></v-text-field>
            </v-col>
            <v-col cols="6">
              <v-text-field
                v-model="jSQLKey"
                counter="50"
                label="SQL KEY"
                hide-details
                required
                :rules="emptyRules.text"
              ></v-text-field>
            </v-col>
          </v-row>
        </v-col>
        <v-col cols="12" sm="2" md="2" class="pt-0 pb-0 mt-0 mb-0">
          <v-select
              v-model="valueStatus"
              :items="itemStatusCat"
              label="Status"
              item-text="name"
              item-value="key"
              multiple
              hide-details
              return-object
              required
              :rules="emptyRules.select2"
            ></v-select>
        </v-col>
      
        <!-- <v-col cols="12" sm="1" md="1" class="pt-5 text-left">
          <v-btn color="success" @click="getWorklogByTicket()"> Search by  Jira Ticket</v-btn>
        </v-col> -->
        
      </v-row>
      <v-row class="mr-5 ml-1 mb-0 pb-0 pt-0 pb-0 mt-0 mb-0">
      
        <v-col cols="12" sm="9" md="9" class="pt-0 pb-0 mt-0 mb-0">
          <v-text-field
            v-model="efforJsonList.jiraDev"
            counter="50"
            hint="jSQL"
            label="jSQL"
            hide-details
          ></v-text-field>
        </v-col>
        <v-col cols="12" sm="1" md="1" class="pt-0 pb-0 mt-0 mb-0 pl-0 pr-0">
          <v-checkbox
            v-model="isShowPicDev"
            label="Show pic DEV"
            hide-details
          ></v-checkbox>
        </v-col>
        <v-col cols="12" sm="1" md="1" class="pt-0 pb-0 mt-0 mb-0">
          <v-text-field
            v-model="efforJsonList.jiraDev"
            :prefix="getPrefixCodeProject"
            counter="50"
            hint="Jira ticket"
            label="Jira ticket"
            hide-details
            @keydown="$event.keyCode === 13 ? getWorklogByTicket() : false"
          ></v-text-field>
        </v-col>
        <v-col cols="12" sm="1" md="1" class="text-right pt-2 pb-0 mt-0 mb-0">
          <v-btn color="success" @click="jiraNewTickets()" default>Search</v-btn>
        </v-col>

      </v-row>
      <v-row>
        <v-col cols="12" sm="12" md="12" class="ma-0 pb-0 pt-0">
          <h3 class="bold">List ticket</h3>
        </v-col>
        <v-col cols="12" sm="12" md="12" class="pt-0">
          <hot-table ref="hotTableComponent" :settings="hotSettings"> </hot-table>
        </v-col>
      </v-row>
      
      <v-row>
        <v-col cols="12" sm="10" md="10" class="mb-0 pb-0">
          <h4>Ticket <span style="color:red"> {{this.jiraIdSeleted}}: {{this.jiraIdTotalHour}}h ({{this.jiraIdTotalHour*25}} point) : {{this.jiraIdStatus}}</span>
          <br/>
          <span> {{this.jiraIdTotalHourDetail}}</span>
          </h4>
        </v-col>
        <v-col cols="12" sm="2" md="2" class="mb-0 pb-0 mt-0 pt-0">
          <!-- <v-btn color="warning" @click="exportCSV()" :disabled='true'> Export CSV</v-btn> -->
          <!-- var exportPlugin1 = hot1.getPlugin('exportFile'); -->
        </v-col>
        <v-col cols="12" sm="12" md="12">
          <!-- <vue-json-editor 
              :expandedOnStart="true"
              :value='ticketJson'
              mode='code'
              >
            </vue-json-editor> -->
            <hot-table ref="hotTableComponentWorkLog" :settings="hotSettingsLWorkLog"> </hot-table>
          </v-col>
      </v-row>
    </v-form>
    <v-overlay :value="overlay">
      <v-progress-circular
        indeterminate
        size="64"
      ></v-progress-circular>
    </v-overlay>
  </v-container>
</template>
<script>
import axios from "axios";
import moment from "moment";
import momentBiz from 'moment-business-days';
import config from "../../../config/config";
// import VueJsonPretty from "vue-json-pretty";
// import "vue-json-pretty/lib/styles.css";
import cookieClient from "vue-cookie";
import vueJsonEditor from "vue-json-editor";
import { HotTable } from "@handsontable-pro/vue";
import Handsontable from "handsontable";
// import '~handsontable/dist/handsontable.full.css'
import "handsontable-pro/dist/handsontable.full.css";

export default {
  components: {
    // VueJsonPretty,
    HotTable,
    vueJsonEditor,
  },
  data() {
    let self = this;
    return {
      // date: new Date((new Date()).valueOf() - 1000*3600*24).toISOString().substr(0, 10),
      emptyRules: {
        text:   [v => !!v || "Item is required"],
        select: [(v) => !!v || "Item is required"],
        select2: [(v) =>  v.length>0 || "Item is required in select 2"],
      },
      date: new Date().toISOString().substr(0, 10),
      date2: new Date().toISOString().substr(0, 10),
      menu: false,
      menu2: false,
      valid: true,
      isShowPicDev: false,
      clvKPI: [],
      team: "Smartlink",
      projectsName: "SPKA",
      valueBoard: {},
      itemsBoard: [],
      valueProject:{},
      valueStatus:[
        {
          key: 'To Do', 
          name: 'To Do'
        }, 
        {
          key: 'In Progress',
          name: 'In Progress'
        },
      ],
      itemsProject: [],
      jSQLKey: 'in',
      isSearchByDate: false,
      itemStatusCat: [
        {
          key: 'To Do', 
          name: 'To Do'
        }, 
        {
          key: 'In Progress',
          name: 'In Progress'
        }, 
        {
          key: 'Done',
          name: 'Done'
        }
        ],
      isBtnDisable: false,
      jiraLinkRoot:
        "https://pim.cyberlogitec.com/jira/rest/clt-gadget/latest/getWorklogByUser.json?",
      jiraLink: "",
      userName:"",
      pwd: "",
      jiraDev:"",
      
      //startdate=2021-04-01&enddate=2021-04-30&projects=SPKA,
      efforJsonList: {
        jiraLink: "",
        userName:"",
        pwd: "",
        jiraDev:"",
        from: this.date,
        to: this.date2,
        // projectsName: "SmartLink [Internal]",
        month: 5,
        week: 10,
        year: 2021,
        NAM: {
          member: "Nam Nguyen Ngoc",
          account: "doudevnn",
          jiraLog: [],
          jiraTicketByTimeH: [],
          total: {},
        },
        DUNG: {
          member: "Dung Cao",
          account: "203737",
          jiraLog: [],
          jiraTicketByTimeH: [],
          total: {},
        },
        KHANH: {
          member: "Khanh Nguyen",
          account: "203728",
          jiraLog: [],
          jiraTicketByTimeH: [],
          total: {},
        },
      },
      pimDATA: [],
      hotSettings: {
        copyPaste: true,
        // data: this.pimDATA,
        startRows: 1000,
        startCols: 15,
        stretchH: "all",
        autoWrapRow: true,
        height: 450,
        maxRows: 1000,
        rowHeaders: true,
        colHeaders: true,
        filters: true,
        multiColumnSorting: true,
        columns: [
          {
            data: "cLTTicket",
            width: 100,
          },
          // {
          //   data: "cLVTicket",
          //   width: 60,
          // },
          {
            data: "taskReceivedDate",
            type: 'date',
            dateFormat: 'YYYY-MM-DD',
            correctFormat: true,
            sortOrder: 'desc',
            width: 110,
          },
          {
            data: "assigner",
            width: 140,
          },
          {
            data: "assignee",
            width: 140,
          },
          {
            data: "clvPIC",
            width: 140,
          },
          // customfield_10906
          {
            data: "status",
            width: 90,
            color:"red"
          },
          // {
          //   data: "project",
          // },
          // {
          //   data: "module",
          //   width: 110,
          // },
          {
            data: "shortDescription",
            width: 300,
          },
          {
            data: "taskType",
            width: 120,
          },
          {
            data: "priority",
            width: 80,
          },
          {
            data: "logtimeTotal",
            width: 60,
            className: "htRight",
          },
          {
            data: "estimatedEffort",
            width: 150,
            text: "right",
            className: "htRight",
          },
         
          {
            data: "planStart",
            width: 90,
          },
          {
            data: "planFinish",
            width: 90,
          },
          // {
          //   data: "jiraId",
          //   width: 60,
          // },
          
          // {
          //   data: "cLTTicket",
          //   text: "center",
          //   width: 100,
          // },
          {
            data: "actualStart",
            width: 90,
          },
          
          {
            data: "actualEnd",
            width: 90,
          },
          {
            data: "picDev",
            width: 140,
          },
        ],
        colHeaders: [
          "CLT Ticket",
          // "CLV Ticket",
          "Received Date",
          "Assigner",
          "Assignee",
          "PIC(CLV)",
          "Status",
          // "Project",
          // "Module",
          "Short Description",
          "Task Type",
          "Priority",
          "PR(h)",
          "EST EF(h)-Agr PR(%)",
          "Plan Start",
          "Plan Finish",
          "ACT Start",
          "ACT End",
          "Main PIC DEV"
        ],
        multiColumnSorting: {
          // sortEmptyCells: true,
          // initialConfig: [ {
          //   column: 12,
          //   sortOrder: 'desc'
          // }]
        },
        contextMenu: true,
        dropdownMenu: ['filter_by_condition', 'filter_action_bar', 'filter_by_value'],
        language: "en-US",
        afterChange: () => {},
        onAfterCreateRow(event) {
          // for (let i = 0; i < this.hot.countCols(); i++) {
          // this.hot.setCellMeta(rowNum - 1, i, 'className', 'blueCell');
          // }
        },
        cells: function(row, col) {
         
          if (col === 0 || col === 9 || col === 10 || col === 12) {
            this.renderer = self.noPlan;
          }
           if (col === 9) {
            this.renderer = self.processCRender;
          }
          if (col === 0 || col === 6) {
            this.renderer = self.inProcessRender;
          }
          //Check plan
          if (col === 0) {
            this.renderer = self.stsSRCRender;
          }
        },
        onKeyDownHandler: function (evt) {
            if (evt.key == 13) {
                const currentVal = dropdown.getValue();
                 console.log('row', 'Enter');
            }
        },
        afterOnCellMouseDown: function afterOnCellMouseDown(_, coords) {
            var cell = this;
            if(coords.row != -1 && coords.col != -1){
              console.log('value', cell.getValue());
              console.log('coords', coords);
              let selected = cell.getSelected();
              let row = selected[0][0];
              let col = selected[0][1];
              console.log('row', selected[0][0]);
              console.log('col', selected[0][1]);

              // let dataSelected = cell.getSourceData()[row][col];
              // console.log('getSourceData', cell.getSourceData());
              let dataSelect = cell.getSourceData()[row];
              if(col != undefined && col === 0){
                console.log('dataSelected', dataSelect);

                let jiraID = cell.getValue();
                self.getWorklogByTicket(cell.getSourceData(), dataSelect.key, dataSelect.jiraID, 'SHEET');
              }
              if(selected != undefined && selected[0][1] == 6){
                let data = cell.getData();
                console.log('data', data);
                let jiraTicket = cell.getValue();
                self.routerLink(dataSelect.key);
                
              }
            }
        }
      },
      hotSettingsLWorkLog: {
        copyPaste: true,
        // data: this.pimDATA,
        startRows: 1000,
        startCols: 15,
        stretchH: "all",
        autoWrapRow: true,
        height: 210,
        maxRows: 1000,
        rowHeaders: true,
        colHeaders: true,
        filters: true,
        multiColumnSorting: true,
        columns: [
          {
            data: "displayName",
            width: 160,
          },
          {
            data: "userId",
            width: 90,
          },
          {
            data: "timeSpent",
             width: 90,
          },
          {
            data: "updated",
            width: 90,
          },
          {
            data: "comment",
          }
        ],
        colHeaders: [
          "DisplayName",
          "UserId",
          "TimeSpent",
          "Updated",
          "Comment",
        ],
        multiColumnSorting: {
          sortEmptyCells: true,
          initialConfig: [ {
            column: 12,
            sortOrder: 'desc'
          }]
        },
        contextMenu: true,
        dropdownMenu: ['filter_by_condition', 'filter_action_bar', 'filter_by_value'],
        language: "en-US",
        afterChange: () => {},
        // afterOnCellMouseDown: function () {
          //   var cell = this;
          //   console.log('value', cell.getValue());
          //   let selected = cell.getSelected();
          //   if(selected != undefined && selected[0][1] == 15){
          //     let data = cell.getData();
          //     let jiraID = cell.getValue();
          //     self.getWorklogByTicketOfline(data, jiraID);
          //   }
          // }
         

      },
      jiraIdSeleted: "",
      jiraIdTotalHour: 0,
      holidays:[
        '2020-09-02'
        ,'2020-04-30'
        ,'2020-05-01'
        ,'2020-01-01'
        ,'2021-01-01'
        ,'2021-02-10'
        ,'2021-02-11'
        ,'2021-02-12'
        ,'2021-02-15'
        ,'2021-02-16'
        ,'2021-04-21'
        ,'2021-04-30'
        ,'2021-05-01'
        ,'2021-05-03'
        ,'2021-09-02'
      ],
      overlay: false,
      jiraIdSeleted: "",
      jiraIdTotalHour: 0,
      jiraIdTotalHourDetail: "",
      jiraIdStatus: "",
      prefixCodeProject: ""
    };
  },
  created() {
    //authen
    // this.$router.push({ name: 'Login' });
    // let userName = self.$cookies.get('userName');
    // if(config.userValid.includes(userName)){
    //   console.log("userName", userName);
    // }else{
    //   return
    // }

    momentBiz.updateLocale('us', {
      holidays: this.holidays,
      holidayFormat: 'YYYY-MM-DD'
    });
    //businessSubtract(-3)
    let dateStartWeek = momentBiz(momentBiz(new Date()).startOf('isoWeek').isoWeekday(2), "YYYY-MM-DD").businessSubtract(3);
    let dateEndWeek = momentBiz(momentBiz(new Date()).startOf('isoWeek').isoWeekday(2), "YYYY-MM-DD").businessSubtract(-2);
    console.log("from", new Date(momentBiz(dateStartWeek, 'YYYY-MM-DD')._d).toISOString().substr(0, 10));
    console.log("to", new Date(momentBiz(dateEndWeek, 'YYYY-MM-DD')._d).toISOString().substr(0, 10));

    this.date = new Date(momentBiz(dateStartWeek, 'YYYY-MM-DD')._d).toISOString().substr(0, 10);
    this.date2 = new Date(momentBiz(dateEndWeek, 'YYYY-MM-DD')._d).toISOString().substr(0, 10);
    
    //Load board data
    this.itemsBoard = JSON.parse(this.$cookies.get('boardList'));
    this.efforJsonList.userName = this.$cookies.get('userName');
    this.efforJsonList.pwd = this.$cookies.get('pwd');
  },
  mounted() {
    // this.jiraNewTickets();
    // prefixCodeProject();
    
  },
  watch: {
    // prefixCodeProject(value){
    //   this.prefixCodeProject = value + "-";
    // },
    date(newVal) {
      // console.log('item changed', newVal);
      this.jiraLink = `https://pim.cyberlogitec.com/jira/rest/clt-gadget/latest/getWorklogByUser.json?startdate=${newVal}&enddate=${this.date2}&projects=${this.projectsName}`;
    },
    date2(newVal) {
      // console.log('item changed', newVal);
      this.jiraLink = `https://pim.cyberlogitec.com/jira/rest/clt-gadget/latest/getWorklogByUser.json?startdate=${this.date}&enddate=${newVal}&projects=${this.projectsName}`;
    },

    btnDisable(){
      // return true
      // if(this.efforJsonList.userName != undefined && this.efforJsonList.userName.trim().length > 0){
      // }
    }
  },
  computed: {
     btnDisable: function () {
       // must parse because Vue turns empty value to string
      if(this.valueBoard.id == undefined){
         return false;
      }
      return true;
     },
     boardDisable: function () {
       // must parse because Vue turns empty value to string
      if(!this.isBtnDisable){
         return false;
      }
      return true;
     },
     getPrefixCodeProject: function(value) {
       if (this.prefixCodeProject == undefined || this.prefixCodeProject == null || this.prefixCodeProject == "" ) return "";
       else return this.prefixCodeProject + "-";
     }
  },
  methods: {
    workday_count(start, end) {
      var first = start.clone().endOf("week"); // end of first week
      var last = end.clone().startOf("week"); // start of last week
      var days = (last.diff(first, "days") * 5) / 7; // this will always multiply of 7
      var wfirst = first.day() - start.day(); // check first week
      if (start.day() == 0) --wfirst; // -1 if start with sunday
      var wlast = end.day() - last.day(); // check last week
      if (end.day() == 6) --wlast; // -1 if end with saturday
      return wfirst + Math.floor(days) + wlast; // get the total
    }, //              ^ EDIT: if days count less than 7 so no decimal point
    onJsonChange(value) {
      var ftest = { date: "2015-02-0", start: 1, end: 7 };
      var ltest = { date: "2015-02-2", start: 2, end: 8 };
      var f = "YYYY-MM-DD";
      var start = moment(ftest.date).add(-1,'days');
      var end = moment(ltest.date).add(1,'days');
      var wd = this.workday_count(start, end);
      console.log("valuewd:", wd);
      // this.efforJsonList.NAM.jiraTicketByTimeH = this.efforJsonList.NAM.jiraLog;
      if (undefined != value) {
        let ticket = null;
        let times = 0;
        this.efforJsonList.NAM.total = {};
        this.efforJsonList.NAM.jiraTicketByTimeH = [];
        for (var i = 0; i < value.issues.length; i++) {
          times += value.issues[i].Worklog / 60 / 60;
          ticket = {
            Issue: value.issues[i].Issue,
            Worklog: value.issues[i].Worklog / 60 / 60,
          };

          this.efforJsonList.NAM.jiraTicketByTimeH.push(ticket);

          //   console.log('valuedd:', this.efforJsonList.NAM.jiraLog.issues[i]);
          //  console.log('index:', i);
        }

        this.efforJsonList.NAM.total.countTicket =
          this.efforJsonList.NAM.jiraTicketByTimeH != undefined
            ? this.efforJsonList.NAM.jiraTicketByTimeH.length
            : 0;
        this.efforJsonList.NAM.total.times = times;
      }
    },

    getEffortJira() {
      this.$cookies.set(
        "crowd.cltems.token_key",
        "lqlZJuuqyynVh4KuuPqGWwAAAAAACYACZG91ZGV2bm4",
        "expiring time"
      );
      this.$cookies.set(
        "JSESSIONID",
        "C0D57CF498029BB85160DB217A0CCA7B",
        "expiring time"
      );
      this.$cookies.set(
        "atlassian.xsrf.token",
        "OX6K_db721eb8bbc90605be85a4afc21424a1def1ec59_lin",
        "expiring time"
      );
      // console.log("CK", this.$cookies.get("NID"));
      axios
        .get(this.jiraLink, {
          headers: {
            cookie:
              "crowd.cltems.token_key=lqlZJuuqyynVh4KuuPqGWwAAAAAACYACZG91ZGV2bm4; JSESSIONID=C0D57CF498029BB85160DB217A0CCA7B; atlassian.xsrf.token=OX6K_db721eb8bbc90605be85a4afc21424a1def1ec59_lin;",
          },
        })
        .then(function (response) {
          console.log("readfolder", response);
        });
    },
    async Insert(member) {
      let seft = this;
      this.efforJsonList.week = parseInt(seft.date.split("-")[1]);
      this.efforJsonList.month = parseInt(seft.date.split("-")[1]);
      this.efforJsonList.year = parseInt(seft.date.split("-")[0]);
      console.log(this.efforJsonList);
      await axios
        .post(config.API_JIRA + "/api/insertKPI", this.efforJsonList)
        .then(function (response) {});
    },
    async reloadBoard(){
      this.jiraBoards();
    },
    async jiraBoards(){
      const seft = this;
      await axios
        .post(`${config.API_JIRA}/api/jiraBoards`, this.efforJsonList)
        .then(async function (response) {
          // seft.hotSettings.data = response.data.data;
          console.log('jiraBoards', response.data);
          // seft.pimDATA = response.data.data;
          seft.itemsBoard = response.data.data;
        });
    },
    async boardChange(){
      const seft = this;
      seft.overlay = true;
      this.efforJsonList.boardId = seft.valueBoard.id;
      await axios
        .post(`${config.API_JIRA}/api/jiraProjects`, this.efforJsonList)
        .then(async function (response) {
          // seft.hotSettings.data = response.data.data;
          console.log('itemsProject', response.data);
          // seft.pimDATA = response.data.data;
          seft.itemsProject = response.data.data;
          seft.overlay = false;
          // seft.btnDisable = false;
          //Set refix defalt = first
          seft.prefixCodeProject = seft.itemsProject[0].key;
        });
    },
   
    async jiraNewTickets() {
      if (!this.$refs.jrTicket.validate()) {
        return;
      }
      const seft = this;
      // seft.isBtnDisable = true;
      seft.overlay = true;
      seft.$refs.hotTableComponent.hotInstance.loadData([]);
      this.efforJsonList.from =  this.date;
      this.efforJsonList.to = this.date2;
      this.efforJsonList.itemsProject = this.itemsProject;
      this.efforJsonList.team = this.team;
      this.efforJsonList.jSQLKey = this.jSQLKey;
      this.efforJsonList.statusCat = this.valueStatus;
      this.efforJsonList.isSearchByDate = this.isSearchByDate;
      this.efforJsonList.picdev = this.isShowPicDev;
     
      await axios
        .post(`${config.API_JIRA}/api/jiraNewTickets`, this.efforJsonList)
        .then(async function (response) {
          // seft.hotSettings.data = response.data.data;
          // console.log('pimDATA', seft.pimDATA);
          // seft.pimDATA = response.data.data;
          // items.customfield_12001.displayName
          
          if(response.data.data != undefined && response.data.data.length > 0){
            let data = response.data.data;
            data.forEach(item => {
              if(item.items.customfield_12001 != undefined &&
                item.items.customfield_12001 != null){
                  item.clvPIC = item.items.customfield_12001.displayName;
              }
            });
            // let data = response.data.data.filter(function(item) { 
            //    console.log('pimDATA', item.items);
            //   // if(item.items.customfield_12001 != undefined &&
            //   //   item.items.customfield_12001 != null){
            //   //     item.clvPIC = item.items.customfield_12001.displayName;
            //   //   }
            // });
           
            await seft.$refs.hotTableComponent.hotInstance.loadData(
              data
            );
          }
          seft.overlay = false;
          // seft.btnDisable = false;
          
          // seft.$refs.hotTableComponent.hotInstance.loadData(seft.pimDATA);
        }).catch((error) => {
          
            if( error.response ){
                console.log(error.response.data); // => the response payload 
                // seft.btnDisable = false;
                seft.overlay = false;
            }
        });
    },
    getWorklogByTicketOfline (sources, data, jiraId) {
      console.log("getWorklogByTicketOfline");
      this.$refs.hotTableComponentWorkLog.hotInstance.loadData([]); 
      let logDatas = sources.filter(function(item) { 
        return item.jiraId === jiraId; 
      });
      this.jiraIdSeleted = logDatas[0].key
      let logs = logDatas[0].worklogList;
      if(logs != undefined && logs.length > 0){
        let arr = [];
        let total = 0;
        for(var i = 0; i < logs.length; i++){
          arr.push({
            "displayName": logs[i].author.displayName,
            "userId": logs[i].author.name,
            "timeSpent":logs[i].timeSpent,
            "updated": moment(logs[i].updated).format("YYYY-MM-DD HH:MM"),
            "comment": logs[i].comment,
          });
          total += logs[i].timeSpentSeconds;
        }
        this.jiraIdTotalHour = total/60/60;
        this.$refs.hotTableComponentWorkLog.hotInstance.loadData(arr);
        console.log("getWorklogByTicketOfline", logDatas[0].worklogList);

      }
    },
    async getWorklogByTicket(sources, jiraKey, jiraId, where){
      const seft = this;
      seft.isBtnDisable = true;
      seft.overlay = true;
      this.efforJsonList.boardId = seft.valueBoard.id;
      this.efforJsonList.ticketid = where !== 'SHEET' ? `${this.prefixCodeProject}-${this.efforJsonList.jiraDev}`: jiraKey;
      this.jiraIdSeleted = where !== 'SHEET' ? `${this.prefixCodeProject}-${this.efforJsonList.jiraDev}` : jiraKey;
      this.jiraIdTotalHourDetail = "";
      await axios
        .post(`${config.API_JIRA}/api/getIssueWorklogs`, this.efforJsonList)
        .then(async function (response) {
          // seft.hotSettings.data = response.data.data;
          console.log('itemsProject', response.data);
          // seft.pimDATA = response.data.data;
          seft.isBtnDisable = false;
          seft.ticketJson =  response.data;
          seft.overlay = false;

          console.log("getWorklogByTicket");
          seft.$refs.hotTableComponentWorkLog.hotInstance.loadData([]); 
          let seen = new Set();
          let arrayDisplay = [];
          let logs = response.data.data;
          let ticket = response.data.tickets;
          let oneHour = 25; //Point
          if(logs != undefined && logs.length > 0){
            let arr = [];
            let total = 0;
            for(let i = 0; i < logs.length; i++){
              arr.push({
                "displayName": logs[i].author.displayName,
                "userId": logs[i].author.name,
                "timeSpent":logs[i].timeSpent,
                "point": parseFloat(logs[i].timeSpentSeconds/60/60) * oneHour,
                "updated": moment(logs[i].updated).format("YYYY-MM-DD HH:MM"),
                "comment": logs[i].comment,
              });
              total += logs[i].timeSpentSeconds;
              seen.add(logs[i].author.displayName);
            }

            //Tong tung nguoi
            for(let user of seen){
              let sum = 0;
              let sumP = 0;
              console.log("seen[j]", user);
              for(let i = 0; i < logs.length; i++){
                if(logs[i].author.displayName == user){
                  sum += logs[i].timeSpentSeconds;
                  sumP += parseFloat(logs[i].timeSpentSeconds/60/60) * oneHour;
                }
              }
              arrayDisplay.push({
                displayName: user,
                timeSpent: sum/60/60,
                point: sumP,
              });
            }
            seft.jiraIdTotalHour = total/60/60;
            seft.jiraIdTotalHourDetail = arrayDisplay.map(mem => `${mem.displayName}: ${mem.timeSpent}h (${mem.point})`).join(' | ');
            console.log("ticket", ticket.issues[0]);
            seft.jiraIdStatus = ticket.issues[0].fields.status.name;
            seft.$refs.hotTableComponentWorkLog.hotInstance.loadData(arr);
            console.log("getWorklogByTicket", arrayDisplay);
          }
          
        });
    },
    stsSRCRender(instance, td, row, col, prop, value, cellProperties) {
        Handsontable.renderers.TextRenderer.apply(this, arguments);
        let pStart = instance.getDataAtCell(row,12);
        let pEnd = instance.getDataAtCell(row,13);
        let actStart = instance.getDataAtCell(row,14);
        let actEnd = instance.getDataAtCell(row,15);
        if(pStart == 'Invalid date'
        || pEnd == 'Invalid date'
        || actStart == 'Invalid date'
        || actEnd == 'Invalid date'){
          td.style.color = '#B22222';
        }
       
      },  
    processCRender(instance, td, row, col, prop, value, cellProperties) {
      Handsontable.renderers.TextRenderer.apply(this, arguments);
        let pr = instance.getDataAtCell(row,9);
        let est = instance.getDataAtCell(row,10);
        console.log("instance.getDataAtCell(row,9)", pr);
        if(est!= undefined){
          let arrEst = est.split(' ');
          if(arrEst != undefined && arrEst.length > 0){
            let val = parseFloat(arrEst[0]) - parseFloat(pr);
            console.log(parseFloat(arrEst[0]));
            console.log(parseFloat(pr));
            console.log(parseFloat(val));
            if(val < 0){
              td.style.background = '#F08080';
              td.style.fontweight = 'bold';
            }else if(val > 0){
              td.style.background = 'lightgreen';
              td.style.fontweight = 'bold';
            }else{
              td.style.background = 'Orange';
            }
           
          }
          
        }
    },
    inProcessRender  (instance, td, row, col, prop, value, cellProperties) {
      Handsontable.renderers.TextRenderer.apply(this, arguments);
        let start = instance.getDataAtCell(row,13);
        let end = instance.getDataAtCell(row,14);
        if(end == undefined || end == 'Invalid date'){
          td.style.background = 'yellow';
          td.style.fontweight = 'bold';
          
        }
    },
    routerLink(jiraTicket){
      // let route = this.$router.resolve({path: `${config.PIM_URL}/${jiraTicket}`});
      // let route = this.$router.resolve('/link/to/page'); // This also works.
      window.open(`${config.PIM_URL}/${jiraTicket}`, '_blank');
    },
    noPlan(instance, td, row, col, prop, value, cellProperties) {
        Handsontable.renderers.TextRenderer.apply(this, arguments);
        let esteff = instance.getDataAtCell(row,8);
        let start = instance.getDataAtCell(row,9);
        let end = instance.getDataAtCell(row,10);
        if(start == undefined || start == null || start == '' || start == 'Invalid date'
        || end == undefined || end == null || end == '' || end == 'Invalid date'
        || esteff == 0){
          td.style.color = 'red';
          td.className = 'yellow_area';
        }

        //Check overduedate
        if(end != undefined && end !=  null && end !=  '' && end !=  'Invalid date'){
          let isOverDueDate = moment(end).isBefore(moment(new Date()).format("YYYY-MM-DD"));
          let sts = instance.getDataAtCell(row,4);
          let arrValidSts = ["Backlog", "Dev In Progress", "Selected for Development"]
          if (isOverDueDate){
            if(arrValidSts.includes(sts)){
              td.className = 'red';

            }
          }
        }
       
        
      },
  },
  
};
</script>
<style scoped>
  .v-data-table {
    width: 100%;
  }
  .v-top {
    vertical-align: top;
  }
  .v-data-table tr td {
    vertical-align: top;
  }
  .v-data-table tr:hover,
  .v-data-table tbody tr:hover:not(.v-data-table__expanded__content) {
    background: #fff !important;
  }
  .menu__content{
    z-index: 9999 !important;
  }
  .v-overlay--active{
    z-index: 9999 !important;
  }
  
</style>
